/*
 * $Id: printerprefs.c,v 1.1.1.1 2005/03/15 16:01:01 laire Exp $
 */
#define AROS_ALMOST_COMPATIBLE
#include "global.h"
#include <proto/iffparse.h>
#include <aros/asmcall.h>

#define DEBUG 0
#include <aros/debug.h>


AROS_UFH1(LONG, PrinterTxtPrefs_Handler,
		  AROS_UFHA(struct IFFHandle *, iff, A2))
{
	AROS_LIBFUNC_INIT

	struct Preferences     prefs;
	struct PrinterTxtPrefs iprefs;
	LONG   retvalue = FALSE;

	D(bug("IPrefs: PrinterPrefs\n"));

	if (ReadChunkBytes(iff, &iprefs, sizeof(iprefs)) == sizeof(iprefs))
	{
		int i;

		GetPrefs(&prefs,sizeof(struct Preferences));

		for(i=0;i<DRIVERNAMESIZE;i++) prefs.PrinterFilename[i] = iprefs.pt_Driver[i];

		prefs.PrinterPort	= iprefs.pt_Port;

		prefs.PrintPitch        = iprefs.pt_Pitch << 10;
		prefs.PrintQuality      = iprefs.pt_Quality << 8;
		prefs.PrintSpacing      = ((iprefs.pt_Spacing == PS_EIGHT_LPI) ? EIGHT_LPI : 0);
		prefs.PrintLeftMargin   = iprefs.pt_LeftMargin;
		prefs.PrintRightMargin  = iprefs.pt_RightMargin;
		prefs.PrinterType       = 0;

		prefs.PaperSize         = iprefs.pt_PaperSize << 4;
		prefs.PaperLength       = iprefs.pt_PaperLength;
		prefs.PaperType         = iprefs.pt_PaperType << 7;

		SetPrefs(&prefs,sizeof(struct Preferences), FALSE);

		retvalue = TRUE;
	}

	return retvalue;

	AROS_LIBFUNC_EXIT
}






AROS_UFH1(LONG, PrinterUnitPrefs_Handler,
		  AROS_UFHA(struct IFFHandle *, iff, A2))
{
	AROS_LIBFUNC_INIT

	struct Preferences     prefs;
	struct PrinterUnitPrefs iprefs;
	LONG   retvalue = FALSE;

	D(bug("IPrefs: PrinterUnitPrefs\n"));

	if (ReadChunkBytes(iff, &iprefs, sizeof(iprefs)) == sizeof(iprefs))
	{
		int i;

		GetPrefs(&prefs,sizeof(struct Preferences));

		for(i=0;i<DEVNAME_SIZE;i++) prefs.PrtDevName[i] = iprefs.pu_DeviceName[i];

		prefs.DefaultPrtUnit	= iprefs.pu_UnitNum;

		SetPrefs(&prefs,sizeof(struct Preferences), FALSE);

		retvalue = TRUE;
	}

	return retvalue;

	AROS_LIBFUNC_EXIT
}
